'VMUSIC1a    getestet
'
'Eingaenge:
'4-Bit-Datenwort von Decoder MT8870 an Eingaenge PB0(LSB) bis PB3(MSB)
'Strobeausgang von Decoder MT8870 an INT0-Eingang PD2
'Steuerung durch 3x DTMF-Ton;
'1.Ton = "*" ; 2.Ton = "1" bis "9"; 3.Ton = "#"
'ser. Dateneingang (9K6) PD0 fuer Quittungssignal ">" von VMUSIC2
'Anwahl Soundfileformat via Eingang PC2: MP3="H"; WAV="L"
'
'Ausgaenge:
'ser. Datenausgang (9K6) PD1 zur Steuerung des VMUSIC2
'Datenformat: "vpf " + <tonnummer> + <fileform> + chr(13);
'tonnummer  = String: "1" bis "9" ( je nach empfangenem DTMF-Ton )
'fileform  = String: ".mp3" ( PC.2="H" ) oder "wav" ( PC.2="L" )
'PTT-Ausgang: PC0
'LED-Ausgang:  PC1

$regfile = "m8def.dat"
$crystal = 8000000
$baud = 9600
$hwstack = 32
$swstack = 10
$framesize = 40

Dim Wt As Byte
Dim Dtmf As Byte
Dim Tonnummer As String * 2
Dim Fileform As String * 5

Dim Wert1 As Byte
Dim Wert2 As Byte
Dim Wert3 As Byte
Dim Wert4 As Byte

Declare Sub Indata
Declare Sub Wait_for_string(byval S As String)

Config Portb = Input
'Pullup PortB
Portb = &B11111111

Config Portc.0 = Output
Config Portc.1 = Output
Config Portc.2 = Input
'Pullup fuer PC.2
Portc = &B00000100

Portc.0 = 0
Portc.1 = 0

Enable Interrupts
Enable Int0

'IRQ-Triggering durch pos.Flanke
Mcucr.0 = 1
Mcucr.1 = 1

On Int0 Isr1

Waitms 500

Start:
'2xLED-Flash
Portc.1 = 1
Waitms 100
Portc.1 = 0
Waitms 100
Portc.1 = 1
Waitms 100
Portc.1 = 0

'warten auf 1. Strobe an IRQ0 ( PD2 )
Wt = 1
Do
Loop Until Wt = 0
Wt = 1

Gosub Indata
'Erkennung von DTMF "*"
If Dtmf <> 11 Then Goto Start

'LED-Flash
Portc.1 = 1
Waitms 100
Portc.1 = 0

'warten auf 2. Strobe an IRQ0 ( PD2 )
Wt = 1
Do
Loop Until Wt = 0
Wt = 1

Gosub Indata
'Erkennung von DTMF 1 bis 9
If Dtmf < 1 Or Dtmf > 9 Then Goto Start
Tonnummer = Str(dtmf)

'LED-Flash
Portc.1 = 1
Waitms 100
Portc.1 = 0

'warten auf 3. Strobe an IRQ0 ( PD2 )
Wt = 1
Do
Loop Until Wt = 0
Wt = 1

Gosub Indata
'Erkennung von DTMF "#"
If Dtmf <> 12 Then Goto Start

'Auswahl Filetyp
If Pinc.2 = 0 Then Goto Wav
Fileform = ".mp3"
Goto Spkstart

Wav:
Fileform = ".wav"

Spkstart:
'PTT und "LED" = "Ein"
Portc.0 = 1
Portc.1 = 1
Waitms 100

'1.Sprachausgabebefehl zum VMUSIC2
Print "vpf 0" + Fileform + Chr(13);
Call Wait_for_string( "D:\>")
Waitms 100

'2. Sprachausgabebefehl zum VMUSIC2
Print "vpf " + Tonnummer + Fileform + Chr(13);
Call Wait_for_string( "D:\>")

'3. Sprachausgabebefehl zum VMUSIC2
Print "vpf 10" + Fileform + Chr(13);
Call Wait_for_string( "D:\>")

Waitms 200
'PTT und "LED" = "Aus"
Portc.0 = 0
Portc.1 = 0
Wait 1
Goto Start

End

'---------------------------------
'Interruptausloesung nach DTMF-Tonerkennung

Isr1:
Wt = 0
Return

'---------------------------------
'Abfrage von DTMF-Bitmuster an PB0-PB3

Sub Indata
If Pinb.0 = 1 Then Wert1 = 1 Else Wert1 = 0
If Pinb.1 = 1 Then Wert2 = 2 Else Wert2 = 0
If Pinb.2 = 1 Then Wert3 = 4 Else Wert3 = 0
If Pinb.3 = 1 Then Wert4 = 8 Else Wert4 = 0

Dtmf = Wert1 + Wert2
Dtmf = Dtmf + Wert3
Dtmf = Dtmf + Wert4
End Sub

'----------------------------------
'warten auf String oder Abbruch bei DTMF-Tonempfang

Sub Wait_for_string(byval S As String) As String
Local Ii As Byte
Local Cc As Byte
Ii = 1
M1:
   If Wt = 0 Then Goto M2
   Cc = Waitkey()
   If Cc <> Mid(s , Ii , 1) Then
      Goto M1
   Else
      Incr Ii
      If Ii > Len(s) Then Goto M2
      Goto M1
   End If
M2:
Wt = 1
End Sub